/*An Implementation for a Stepper Motor which ist controllable with a Step and a direction Pin. A turn right is  a clockwise and a turn left ist an anti-clockwise turn of the axis.
 *The class uses diffrent methods to use the Stepper Motor. At one hand it's possible to use global variables for pins, direction and delay values and at the other hand is's possible to 
 *use specified parameters. 
 *@author Yuri Gbur 
 *updated: 01/03/14
 */
#ifndef StepperMotor_h
#define StepperMotor_h
#include "Arduino.h"

class StepperMotor{
public:
    StepperMotor();                         //Initalize a default instance of the StepperMotor
    StepperMotor(int stp, int dir);          //Initalize an instance with the pins for direction and steps
    StepperMotor(int stp, int dir, int delayValue);        //Initalize an instance with the pins for direction and steps and set the global delay to the given value
    enum Direction{                                        
      RIGHT,LEFT,Undefined
    };
    void setGlobalDelay(int delayValue);                 //Set the time for the global delay to control the speed
    void setDir(Direction newdir);                     //Set the global direction for the StepperMotor
    void stepLeft();                             //Turns one step left with the global delay
    void stepRight();                            //Turns one step right with the global delay
    void doStep(Direction newdir);                // Turns one step to the given Direction
    void stepsLeft(int steps);                      //Turn steps for the amount of given steps  
    void stepsRight(int steps);                      //Turn steps fot the amount of given steps
    void stepLeft(int delayValue);                    //Turns one step left with a given delay Value
    void stepRight(int delayValue);                   //Turns one step right with a given delay Value
    void setStepPin(int stp);                   //Set the step-pin to the given pin
    void setDirPin(int dir);      //Set the direction-pin to the  given pin
private:
    int stp;                               //Stepper-Pin value
    int dir;                                //Diretion-Pin value
    int delayValue;                        //delay Value to control the speed
    Direction direction;
    
    
};

#endif
