#ifndef WWSR_h
#define WWSR_h
#include "Arduino.h"

//Imports für WlanAntenne
#include <WiFlyHQ.h>
#include <ArdOSCForWiFlyHQ.h>

//Imports für Servo
#include <Servo.h>

#include "StepperMotor.h"


class Fahren{
public:
  Fahren(int stepR, int dirR, int stepL, int dirL);
  void nachVorneFahren(int delayValue, int steps);
  void linksDrehung(int delayValue, int steps);
  void rechtsDrehung(int delayValue, int steps);
private:
  StepperMotor rechts;
  StepperMotor links;
  int stepR; //Rechtes Rad
  int dirR;
  int stepL; //Linkes Rad
  int dirL;

};
class StepperAntenne{
public:
  StepperAntenne(int stepA, int dirA);
  void connect();
  int getSignal();
  void printSignal();
  int imUhrScannung();
  int gegenUhrScannung();
private:
  int stepA;
  int dirA;
  StepperMotor richtmotor;
  int ledPin;
  WiFly wifly;
  int hoechsterWifiWert;
  float posOptimaleStepAnzahl;
  float negOptimaleStepAnzahl;
  int hoechsterWertCounter;
  int wifiWert;

};
class SonarRaumwahrnehmung{	
public:
  SonarRaumwahrnehmung();
  long entfernungsMesser();  //Servo nicht in SonarRaumwahrnehmung
private:
  int trigger;
  int echo;
  long duration, cm;
  long microsecondsToCentimeters(long microseconds);
};
#endif

